<?php

// just a template file, no heavy lifting here
global $wpdb, $table_prefix;

if (!defined('ABSPATH'))
	die('no');

if ($wpdb->get_var("SHOW TABLES LIKE '{$table_prefix}democracyQ'") != $table_prefix."democracyQ")
{
	jal_install_democracy();
}


$poll_id = isset($_GET['dem_poll_id']) ? (int) $_GET['dem_poll_id'] : false;

// a poll has been deleted
if (isset($_GET['jal_dem_delete']))
{
    echo "\n\t<div class='updated'>";
    echo "\n\t\t<p>".__('The poll was deleted.', 'democracy')."</p>";
    echo "\n\t</div>";
}

function editScreen($editing = false)
{
	global $wpdb, $table_prefix;
	
	$poll_id = $editing;

	$checked = ' checked="checked"';
	if ($editing)
	{
		$title = __('Edit Poll', 'democracy');
		
		$poll = $wpdb->get_row("SELECT * FROM {$table_prefix}democracyQ WHERE id = {$poll_id} LIMIT 1");
		$answers = $wpdb->get_results("SELECT * FROM {$table_prefix}democracyA WHERE qid = {$poll_id}");

		$question = htmlspecialchars(stripslashes($poll->question));

		$choices = array();
		foreach ($answers as $answer)
			$choices[] = array("jal_dem_old_answer[{$answer->aid}]", htmlspecialchars(stripslashes($answer->answer)));

		$current = ($poll->current) ? $checked : '';
		$multiple = ($poll->multiple) ? $checked : '';
		$allow_users = ($poll->allowusers) ? $checked : '';
		
		$edit_inputs = "<input type='hidden' name='dem_poll_id' value='{$poll_id}' />";
		$edit_inputs .= "<input type='hidden' name='jal_edit_poll' value='1' />";
		
	}
	
	else
	{
		$title = __('Add a Poll', 'democracy');
		$question = '';
		
		$choices = array();
		for ($i = 0; $i < 4; $i++)
			$choices[] = array('jal_dem_answers[]', '');

		$current = $checked;
		$multiple = '';
		$allow_users = '';
		
		$edit_inputs = "<input type='hidden' name='jal_create_poll' value='1' />";
		
	}
	
	
	// ===============================================
	
	echo "\n\t<div class='wrap'>\n";
    	
    	// beginning of Add A Poll
		echo "\n\t\t<h2>{$title}</h2>";    	
    	
    	
		echo "\n\t\t<form action='edit.php?page=democracy' method='post'><div id='new-poll'>";
		    			
		    echo "\n\t\t\t<label for='the-question' id='the-question-label'>",__('Question:', 'democracy'),"</label>";
		    echo "\n\t\t\t<input type='text' id='the-question' name='jal_dem_question' value=\"{$question}\" />";
		    echo "\n\t\t\t<strong>",__('Answers:', 'democracy'),"</strong>";

		    echo "\n\t\t\t<ol id='dem-answers'>";
		    
	
		    	foreach ($choices as $choice)
		    	{
		    		echo "\n\t\t\t\t<li>";
		    			echo "<input type='text' name=\"{$choice[0]}\" value=\"{$choice[1]}\" />";
		    		echo "\n\t\t\t\t</li>";
		    	}
		    	
		    	echo "\n\t\t\t\t<li id='answerButtons'>";
		    		echo "\n\t\t\t\t\t<button onclick='return addAnswer()'>",__('Add an Answer', 'democracy'),"</button> ";
		    		echo "\n\t\t\t\t\t<button id='remove-answer' onclick='return removeAnswer(this)'>",__('Remove an Answer', 'democracy'),"</button>";
		    	echo "\n\t\t\t\t</li>";

		    
		    echo "\n\t\t\t</ol>";
		    
		    echo "\n\t\t\t<strong>",__('Options:'),"</strong>";
		    echo "\n\t\t\t<ol class='poll-options'>";
		    echo "\n\t\t\t\t<li><input type='checkbox'{$current} name='jal_dem_current_poll' value='1' id='jal_dem_current_poll' /> <label for='jal_dem_current_poll'>",__('Make this the current poll', 'democracy'),"</label></li>";
			// CURRENTLY non-functional
//		    echo "\n\t\t\t\t<li><input type='checkbox'{$multiple} name='jal_dem_multiple' id='jal_dem_multiple' value='1' /> <label for='jal_dem_multiple'>",__('Use checkboxes (NON FUNCTIONAL)', 'democracy'),"</label></li>";
		    echo "\n\t\t\t\t<li><input type='checkbox'{$allow_users} name='jal_dem_allow_users' id='jal_dem_allow_users' value='1' /> <label for='jal_dem_allow_users'>",__('Allow users to add choices', 'democracy'),"</label></li>";
		    echo "\n\t\t\t</ol>";
		
		    echo $edit_inputs;
		
		    echo "\n\t\t\t<input type='submit' class='the-poll-submit' value='",__('Submit', 'democracy'),"' />";
		    
		
		echo "\n\t\t</div></form>";

    // .wrap
	echo "\n\t</div>\n";
	
	
}




// editing a specific poll
if ($poll_id && isset($_GET['edit']))
{
	
	editScreen($poll_id);
    
}

// showing management page
else 
{


    $polls = $wpdb->get_results("
    SELECT *
    FROM {$table_prefix}democracyQ as q
    ORDER BY q.id DESC
    ");

	echo "\n\n\t<div class='wrap'>";
	echo "\n\t\t<h2>",__('Manage Polls', 'democracy'),"</h2>";    	

	if ($polls)
	{
    	// extract the current poll id
    	$current = 0;
    	foreach ($polls as $poll)
    	{
    		if ($poll->current == "1")
    		{
    			$current = $poll->id;
    			break;
    		}
    	}

    	$votes_total = $wpdb->get_results("
    	 SELECT SUM(votes) as total_votes, qid
    	 FROM {$table_prefix}democracyA
    	 GROUP BY qid
    	", ARRAY_A);

    	
    	// indexed by poll id, contains total votes
    	$totalvotes = array();
    	if ($votes_total)
    		foreach ($votes_total as $poll_total)
    			$totalvotes[$poll_total['qid']] = $poll_total['total_votes'];

 		$winner_answers = $wpdb->get_results("
 		 SELECT votes, answer, qid
 		 FROM {$table_prefix}democracyA
 		 GROUP BY qid, votes
 		 ORDER BY qid
 		", ARRAY_A);

    	// indexed by poll id, contains c votes
    	$winners = array();
    	if ($winner_answers)	
    		foreach ($winner_answers as $the_winner)
    		{
    			$answer = ($the_winner['votes'] > 0) ? stripslashes($the_winner['answer']) : "<i>".__('None Yet', 'democracy')."</i>";
    			$winners[$the_winner['qid']] = array($answer, $the_winner['votes']);
    		}
    	
    	unset ($votes_total, $winner_answers);
		
    	if ($current == 0)
    	{
    	   echo "\n\t\t<div class='error'>";
    	       echo "\n\t\t\t<p>";
    	           echo "\n\t\t\t<strong>".__('You have no active polls', 'democracy').'</strong><br />';
    	           _e('Any sections of your site where you have inserted the Democracy code will <strong>appear empty</strong>. To change this, create a new poll or click "Activate" on a poll below.', 'democracy');
    	       echo "</p>\n";
    	   echo "\n\t\t</div>";
    	}
    	
    	echo "\n\t\t<table class='dem-manage' cellspacing='3' cellpadding='3'>";
    	
    	    echo "\n\t\t\t<tr>";
    	    	echo "\n\t\t\t\t<th scope='col'>",__('ID', 'democracy'),"</th>";
    	    	echo "\n\t\t\t\t<th scope='col'>",__('Question', 'democracy'),"</th>";
    	    	echo "\n\t\t\t\t<th scope='col'>",__('Total Votes', 'democracy'),"</th>";
    	    	echo "\n\t\t\t\t<th scope='col'>",__('Winner', 'democracy'),"</th>";
    	    	echo "\n\t\t\t\t<th scope='col'>",__('Date Added', 'democracy'),"</th>";
    	    	echo "\n\t\t\t\t<th scope='col'>",__('Action', 'democracy'),"</th>";
    	    echo "\n\t\t\t</tr>";
    	    
    	
    	$class = '';
    	
    	foreach ($polls as $poll)
    	{
    	    $question = stripslashes($poll->question);
    	    $date = date(get_settings('date_format'), $poll->added);
    	    
    	    $total = isset($totalvotes[$poll->id]) ? $totalvotes[$poll->id] : 0;
    	    
    	    // if there ever need to lots of classes involved
		    $classes = array();

    	    if ($class == '')
		    	$classes[] = 'alternate';
		    	
    	    if ($current == $poll->id)
    	    {
    	    	$total = "So far, {$total}";
    	    	$classes[] = 'active';
    	    }

		    	
    	    	
    	    $class = (empty($classes)) ? '' : ' class="'.implode(' ', $classes).'"'; 
    	    	
    	    $winner = isset($winners[$poll->id][0]) ? $winners[$poll->id][0] : '<i>'.__('None', 'democracy').'</i>';
    	    if (isset($winners[$poll->id][0]))
    	    	$title = ' title="'.sprintf(__('Received %s Votes', 'democracy'), $winners[$poll->id][1]).'"';
    	    else
    	    	$title = '';

    	    echo "\n\t\t\t<tr{$class}>";
    	    	echo "\n\t\t\t\t<td>{$poll->id}</td>";
    	    	echo "\n\t\t\t\t<td>{$question}</td>";
    	    	echo "\n\t\t\t\t<td>{$total}</td>";
    	    	echo "\n\t\t\t\t<td{$title}>{$winner}</td>";
    	    	echo "\n\t\t\t\t<td>{$date}</td>";
    	    	
    	    	echo "\n\t\t\t\t<td>";
    	    		echo "\n\t\t\t\t\t<form action='' method='get'><div>";
               			echo "\n\t\t\t\t\t\t<input type='hidden' name='page' value='democracy' />";
               			echo "\n\t\t\t\t\t\t<input type='hidden' name='dem_poll_id' value='{$poll->id}' />";
               			
               			if ($current == $poll->id)
               				echo "\n\t\t\t\t\t\t<input type='submit' value='",__('Deactivate', 'democracy'),"' name='jal_dem_deactivate'>";
               			else
               				echo "\n\t\t\t\t\t\t<input type='submit' value='",__('Activate', 'democracy'),"' name='jal_dem_activate'>";
/*
               			if ($poll->active)
               				echo "\n\t\t\t\t\t\t<input type='submit' value='",__('Close Voting', 'democracy'),"' name='jal_dem_close'>";
               			else
               				echo "\n\t\t\t\t\t\t<input type='submit' value='",__('Open Voting', 'democracy'),"' name='jal_dem_open'>";
*/
               			echo "\n\t\t\t\t\t\t<input type='submit' value='",__('Edit', 'democracy'),"' name='edit'>";
                		echo "\n\t\t\t\t\t\t<input type='submit' value='",__('Delete', 'democracy'),"' onclick='return confirm(\"",__('You are about to delete this poll.\n  \"Cancel\" to stop, \"OK\" to delete.', 'democracy'),"\");' name='jal_dem_delete' class='delete' />";
    	    		echo "\n\t\t\t\t\t</div></form>";
    	    	echo "\n\t\t\t\t</td>";
    	    echo "\n\t\t\t</tr>";
    	    
    	}
    	
    	echo "\n\t\t</table>";
    	// end of manager
    
    } 
    else 
	{
		echo "\n\t<div class='error'>";
			echo "\n\t\t<p>",__("There are no polls in the democracy database", 'democracy'),"</p>";
		echo "\n\t</div>\n";
	}

    // .wrap
	echo "\n\t</div>\n";



	editScreen(false);


	
	echo "\n\t<div class='wrap' id='dem-gen-options'>";
	
	   // Beginning of General Options
	   echo "\n\t\t<h2>",__('General Options', 'democracy'),'</h2>';
	   
	   global $wp_roles; 

	   foreach ($wp_roles->roles as $role)
	   {
	       if (isset($role['capabilities']['democracy_admin']))
	           $democracy_users[] = $role['name'];
	   }

	   echo "\n\t\t<p>";
	   echo "\n\t\t\t<strong>",__('WordPress roles that can use this page:', 'democracy'),'</strong> ';
	   echo implode(', ', $democracy_users);

	   echo "\n\t\t\t<em>",__('Use of this Democracy admin panel is restricted to the above roles.', 'democracy');
       echo ' ';
       
       // if they have the plugin, link them to it..
	   if (class_exists('RoleManager'))
	       _e('To change this, go to the <a href="profile.php?page=role-manager/role-manager.php">Role Manager admin panel</a>. It is listed as "Democracy Admin"');
	   else
	       _e('To change this, you will need the <a href="http://www.redalt.com/wiki/Role+Manager">Role Manager</a> plugin.', 'democracy');

	   echo '</em>';
	   echo "\n\t\t</p>";
	   
	   
	   echo "\n\t\t<form action='edit.php?page=democracy' method='post'>";
	   
	       // IP Logging option
	       $checked = (get_option('democracy_logIPs') == 1) ? ' checked="checked"' : '';
	       echo "\n\t\t\t\t<p>";
	       echo "\n\t\t\t\t\t<input{$checked} type='checkbox' value='1' name='democracy_logIPs' id='democracy_logIPs' /> <label for='democracy_logIPs'>",__('Log IPs', 'democracy'),"</label>";
	       echo "\n\t\t\t\t\t<em>",__('IP logging prevents people from "stuffing the ballot box", or voting more than once. Democracy uses both cookies and IP logging to prevent users from cheating. IP logging does have a downside: some people share IPs (corporate offices, for example). Or you may simply want to allow people to cheat...Default: On', 'democracy'),'</em>';
	       echo "\n\t\t\t\t</p>";
	       
	       // Graphing from total votes option
	       $checked = (get_option('democracy_graph_from_total') == 1) ? ' checked="checked"' : '';
	       echo "\n\t\t\t\t<p>";
	       echo "\n\t\t\t\t\t<input{$checked} type='checkbox' value='1' name='democracy_graph_from_total' id='democracy_graph_from_total' /> <label for='democracy_graph_from_total'>",__('Graph percentages from total votes', 'democracy'),"</label>";
	       echo "\n\t\t\t\t\t<em>",__('By default, votes are graphed from the current winner. That is, the current winner gets a full 100% bar and the other choices are given bars based on their proportion to the current winner. Generally, the default way makes the bars bigger and easier to read without sacrificing meaning. Default: Off', 'democracy'),'</em>';
	       echo "\n\t\t\t\t</p>";
	       
	       // cookie expiration time
	       echo "\n\t\t\t\t<p>";
	       echo "\n\t\t\t\t\t<input type='text' size='3' value='".get_option('democracy_cookie_days')."' name='democracy_cookie_days' id='democracy_cookie_days' /> <label for='democracy_cookie_days'>",__('Days cookies should last', 'democracy'),"</label>";
	       echo "\n\t\t\t\t\t<em>",__('The number of days cookies should last before they expire. Lower the number to allow people to vote again in x number of days. <strong>NOTE: They will only be able to vote again if IP logging is OFF.</strong> Default: 365.', 'democracy'),'</em>';
	       echo "\n\t\t\t\t</p>";
	       
	       // Order of answers
	       $checked = (get_option('democracy_order_answers') == 1) ? ' checked="checked"' : '';
	       echo "\n\t\t\t\t<p>";
	       echo "\n\t\t\t\t\t<input{$checked} type='checkbox' value='1' name='democracy_order_answers' id='democracy_order_answers' /> <label for='democracy_order_answers'>",__('Order answers by votes', 'democracy'),"</label>";
	       echo "\n\t\t\t\t\t<em>",__('If checked, the answers will be listed in order of how many votes they have received. Default: Off', 'democracy'),'</em>';
	       echo "\n\t\t\t\t</p>";
	       
	       // HTML before and after the question
	       echo "\n\t\t\t\t<p>";
	       echo "\n\t\t\t\t\t<input type='text' size='25' value='".htmlspecialchars(stripslashes(get_option('democracy_before_title')))."' name='democracy_before_title' /> <i>",__('Question Text', 'democracy'),"</i> <input type='text' size='25' value='".htmlspecialchars(stripslashes(get_option('democracy_after_title')))."' name='democracy_after_title' />";
	       echo "\n\t\t\t\t\t<em>",__('This option controls what HTML will wrap around the poll question when it is displayed. It may work better for some themes to use &lt;h2&gt; and &lt;/h2&gt;. Default: &lt;strong class=&quot;poll-question&quot;&gt; <big>/</big> &lt;/strong&gt;.', 'democracy'),'</em>';
	       echo "\n\t\t\t\t</p>";

	       echo "\n\t\t\t\t<input type='submit' name='jal_dem_gen_options' class='the-poll-submit' value='",__('Save Options', 'democracy'),"' />";

	   echo "</form>";
	   

	   
    // .wrap
	echo "\n\t</div>\n";

}

?>