<?php
/*
Plugin Name: Democracy Widget
Plugin URI: http://blog.jalenack.com/archives/democracy/
Description: Adds a sidebar widget for use with Andrew Sutherland's Democracy Poll widget.
Author: Andrew Sutherland
Version: 1.0
Author URI: http://jalenack.com/
*/

/*
	This code is based on Wayback_Widget, by Sven Weidauer (web:dergraf.net email:dergraf@dergraf.net)
	And thanks to Alkar (http://alkar.info/) for developing the original Democracy widget

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function widget_democracy_init()
{
	if (!function_exists('register_sidebar_widget')) return;
	if (!function_exists('jal_democracy')) return;
	
	function widget_democracy( $args )
	{
		extract( $args );
		$options = get_option( 'widget_democracy' );
		$title = $options['title'];
		
		if ($options['questionIsTitle']) {
			echo $before_widget;
			jal_democracy(0, $before_title, $after_title);
			echo $after_widget;
		}
		else 
		{
			echo $before_widget . $before_title . $title . $after_title;
			jal_democracy(0);
			echo $after_widget;
		}
	}

	function widget_democracy_control()
	{
		$options = get_option( 'widget_democracy' );
		if (!is_array( $options ))
		{
			$options = array(
				'title' => 'Poll',
				'questionIsTitle' => '0'
			);
		}
		
		if ($_POST['democracySubmit']) {
			$options['title'] = stripslashes($_POST['democracyTitle']);
			$options['questionIsTitle'] = (isset($_POST['questionIsTitle'])) ? 1 : 0;
			update_option( 'widget_democracy', $options );
		}
		
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$checked = ($options['questionIsTitle']) ? ' checked="checked"' : '';
		
		echo '<p>';
			echo "<input type='checkbox'{$checked} onclick='democracyCheck(this)' id='questionIsTitle' name='questionIsTitle' value='1' /> ";
			echo "<label for='questionIsTitle'>".__('Use the poll question as the title', 'democracy')."</label>";
		echo '</p>';
		
		echo '<p id="demTitleWrap">';
			echo "<label for='democracyTitle'>".__('Title: ', 'democracy')."</label>";
			echo "<input type='text' id='democracyTitle' name='democracyTitle' value='{$title}' />";
			echo '<input type="hidden" id="democracySubmit" name="democracySubmit" value="1" />';
		echo '</p>';
		
		?>
		<script type='text/javascript'>
			<?php if ($checked) { ?>
			Element.hide('demTitleWrap');
			<?php } ?>
			function democracyCheck (that) {
				if (!that.checked)
					Effect.Appear('demTitleWrap');
				else
					Effect.Fade('demTitleWrap');
			}
		</script>
		<?php

	}
	
	register_sidebar_widget( 'Democracy', 'widget_democracy' );
	register_widget_control( 'Democracy', 'widget_democracy_control', 440, 120 );
}

add_action( 'plugins_loaded', 'widget_democracy_init' );

?>